// File generated on 12/14/2021 9:50:06 PM by java4delphi https://www.winsoft.sk/java4delphi.htm

{$WARN UNSAFE_TYPE OFF}
{$WARN UNSAFE_CODE OFF}

unit Test_class;

interface

uses JNI, Java4Delphi;

type
  Ijava_lang_Object = interface;
  Tjava_lang_Object = class;
  Itest_Test = interface;
  Ttest_Test = class;

  Ijava_lang_Object = interface(IJavaObject)
    function equals(param0: Ijava_lang_Object): Boolean;
//    function getClass: Ijava_lang_Class;
    function hashCode: Integer;
    procedure notify;
    procedure notifyAll;
    function toString: WString;
    procedure wait(param0: Int64); overload;
    procedure wait(param0: Int64; param1: Integer); overload;
    procedure wait; overload;
  end;

  Tjava_lang_Object = class(TJavaObject, Ijava_lang_Object)
  protected
    function equals(param0: Ijava_lang_Object): Boolean;
//    function getClass: Ijava_lang_Class;
    function hashCode: Integer;
    procedure notify;
    procedure notifyAll;
    function toString: WString;
    procedure wait(param0: Int64); overload;
    procedure wait(param0: Int64; param1: Integer); overload;
    procedure wait; overload;
  public
    constructor Create(JavaObject: JObject); overload;
    constructor Create; overload;
  end;

  Tjava_lang_ObjectClass = class(TJavaClass)
  protected
    F_initID: JMethodID;
    FequalsID: JMethodID;
    FgetClassID: JMethodID;
    FhashCodeID: JMethodID;
    FnotifyID: JMethodID;
    FnotifyAllID: JMethodID;
    FtoStringID: JMethodID;
    FwaitID_1: JMethodID;
    FwaitID_2: JMethodID;
    FwaitID_3: JMethodID;
    constructor Create(const ClassName: AnsiString; Initialize: Boolean);
  public
    property _initID: JMethodID read F_initID;
    property equalsID: JMethodID read FequalsID;
    property getClassID: JMethodID read FgetClassID;
    property hashCodeID: JMethodID read FhashCodeID;
    property notifyID: JMethodID read FnotifyID;
    property notifyAllID: JMethodID read FnotifyAllID;
    property toStringID: JMethodID read FtoStringID;
    property waitID_1: JMethodID read FwaitID_1;
    property waitID_2: JMethodID read FwaitID_2;
    property waitID_3: JMethodID read FwaitID_3;
  end;

  Itest_Test = interface(Ijava_lang_Object)
    function hello: WString;
  end;

  Ttest_Test = class(Tjava_lang_Object, Itest_Test)
  protected
    function hello: WString;
  public
    constructor Create(JavaObject: JObject); overload;
    constructor Create; overload;
  end;

  Ttest_TestClass = class(Tjava_lang_ObjectClass)
  protected
    F_initID: JMethodID;
    FhelloID: JMethodID;
    constructor Create(const ClassName: AnsiString; Initialize: Boolean);
  public
    property _initID: JMethodID read F_initID;
    property helloID: JMethodID read FhelloID;
  end;

function Get_java_lang_ObjectClass: Tjava_lang_ObjectClass;
function Get_test_TestClass: Ttest_TestClass;

implementation

var java_lang_ObjectClass: Tjava_lang_ObjectClass;

constructor Tjava_lang_Object.Create(JavaObject: JObject);
begin
  Get_java_lang_ObjectClass;
  inherited Create(JavaObject);
end;

constructor Tjava_lang_Object.Create;
begin
  Get_java_lang_ObjectClass;
  inherited Create(JavaBridge.NewObjectA(java_lang_ObjectClass.JavaClass, java_lang_ObjectClass.F_initID, nil));
  CheckJavaException;
end;

function Tjava_lang_Object.equals(param0: Ijava_lang_Object): Boolean;
var Arguments: array [0..0] of JValue;
begin
  Arguments[0].L := GetObject(param0);
  Result := JavaBridge.CallBooleanMethodA(JavaObject, java_lang_ObjectClass.FequalsID, @Arguments[0]);
  CheckJavaException;
end;

{
function Tjava_lang_Object.getClass: Ijava_lang_Class;
var JavaResult: JObject;
begin
  JavaResult := JavaBridge.CallObjectMethodA(JavaObject, java_lang_ObjectClass.FgetClassID, nil);
  Result := Tjava_lang_Class.Create(JavaResult);  CheckJavaException;
end;
}

function Tjava_lang_Object.hashCode: Integer;
begin
  Result := JavaBridge.CallIntMethodA(JavaObject, java_lang_ObjectClass.FhashCodeID, nil);
  CheckJavaException;
end;

procedure Tjava_lang_Object.notify;
begin
  JavaBridge.CallVoidMethodA(JavaObject, java_lang_ObjectClass.FnotifyID, nil);
  CheckJavaException;
end;

procedure Tjava_lang_Object.notifyAll;
begin
  JavaBridge.CallVoidMethodA(JavaObject, java_lang_ObjectClass.FnotifyAllID, nil);
  CheckJavaException;
end;

function Tjava_lang_Object.toString: WString;
begin
  Result := GetString(JavaBridge.CallObjectMethodA(JavaObject, java_lang_ObjectClass.FtoStringID, nil));
  CheckJavaException;
end;

procedure Tjava_lang_Object.wait(param0: Int64);
var Arguments: array [0..0] of JValue;
begin
  Arguments[0].J := param0;
  JavaBridge.CallVoidMethodA(JavaObject, java_lang_ObjectClass.FwaitID_1, @Arguments[0]);
  CheckJavaException;
end;

procedure Tjava_lang_Object.wait(param0: Int64; param1: Integer);
var Arguments: array [0..1] of JValue;
begin
  Arguments[0].J := param0;
  Arguments[1].I := param1;
  JavaBridge.CallVoidMethodA(JavaObject, java_lang_ObjectClass.FwaitID_2, @Arguments[0]);
  CheckJavaException;
end;

procedure Tjava_lang_Object.wait;
begin
  JavaBridge.CallVoidMethodA(JavaObject, java_lang_ObjectClass.FwaitID_3, nil);
  CheckJavaException;
end;

function Get_java_lang_ObjectClass: Tjava_lang_ObjectClass;
begin
  if java_lang_ObjectClass = nil then
    java_lang_ObjectClass := Tjava_lang_ObjectClass.Create('java/lang/Object', True);
  Result := java_lang_ObjectClass;
end;

constructor Tjava_lang_ObjectClass.Create(const ClassName: AnsiString; Initialize: Boolean);
begin
  inherited Create(ClassName, False);
  if Initialize then
    F_initID := Java4Delphi.GetMethodID(JavaClass, '<init>', '()V');
  FequalsID := Java4Delphi.GetMethodID(JavaClass, 'equals', '(Ljava/lang/Object;)Z');
  FgetClassID := Java4Delphi.GetMethodID(JavaClass, 'getClass', '()Ljava/lang/Class;');
  FhashCodeID := Java4Delphi.GetMethodID(JavaClass, 'hashCode', '()I');
  FnotifyID := Java4Delphi.GetMethodID(JavaClass, 'notify', '()V');
  FnotifyAllID := Java4Delphi.GetMethodID(JavaClass, 'notifyAll', '()V');
  FtoStringID := Java4Delphi.GetMethodID(JavaClass, 'toString', '()Ljava/lang/String;');
  FwaitID_1 := Java4Delphi.GetMethodID(JavaClass, 'wait', '(J)V');
  FwaitID_2 := Java4Delphi.GetMethodID(JavaClass, 'wait', '(JI)V');
  FwaitID_3 := Java4Delphi.GetMethodID(JavaClass, 'wait', '()V');
end;

var test_TestClass: Ttest_TestClass;

constructor Ttest_Test.Create(JavaObject: JObject);
begin
  Get_test_TestClass;
  inherited Create(JavaObject);
end;

constructor Ttest_Test.Create;
begin
  Get_test_TestClass;
  inherited Create(JavaBridge.NewObjectA(test_TestClass.JavaClass, test_TestClass.F_initID, nil));
  CheckJavaException;
end;

function Ttest_Test.hello: WString;
begin
  Result := GetString(JavaBridge.CallObjectMethodA(JavaObject, test_TestClass.FhelloID, nil));
  CheckJavaException;
end;

function Get_test_TestClass: Ttest_TestClass;
begin
  if test_TestClass = nil then
    test_TestClass := Ttest_TestClass.Create('test/Test', True);
  Result := test_TestClass;
end;

constructor Ttest_TestClass.Create(const ClassName: AnsiString; Initialize: Boolean);
begin
  inherited Create(ClassName, False);
  if Initialize then
    F_initID := Java4Delphi.GetMethodID(JavaClass, '<init>', '()V');
  FhelloID := Java4Delphi.GetMethodID(JavaClass, 'hello', '()Ljava/lang/String;');
end;

initialization

finalization
  java_lang_ObjectClass.Free;
  test_TestClass.Free;
end.